package org.eclipse.wtp.releng.cvslog.tools;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.wtp.releng.cvstools.CvsdeltaDocument;
import org.eclipse.wtp.releng.cvstools.RevisionDocument;

public class CVSDelta {
	
	public  String file;
	public  String folder;
	public  String head;
	public  String branch;
	public  String keywords;
	private List   revisions = new ArrayList();

	public CvsdeltaDocument toXML()
	{
		CvsdeltaDocument cvsdeltaDocument = CvsdeltaDocument.Factory.newInstance();
		cvsdeltaDocument.addNewCvsdelta();
		CvsdeltaDocument.Cvsdelta cvsdelta = cvsdeltaDocument.getCvsdelta();
		toXML(cvsdelta);
		return cvsdeltaDocument;
	}



	public CvsdeltaDocument.Cvsdelta toXML(CvsdeltaDocument.Cvsdelta cvsdelta) {
		int indexOfV  = file.indexOf(',');
		if(indexOfV > 0)
			file = file.substring(0,indexOfV);
		cvsdelta.setFile(folder+'/'+file);
		cvsdelta.setHead(head);
		cvsdelta.setKeywords("kv");
		cvsdelta.addNewBranch();
		cvsdelta.getBranch().getDomNode().setNodeValue(branch);
		Iterator revs = revisions.iterator();
		while (revs.hasNext()) {
			CVSRevision rev = (CVSRevision) revs.next();
			RevisionDocument.Revision revx = cvsdelta.addNewRevision();
			rev.toXML(revx);
		}
		
		return cvsdelta;
	}
	
	public String toString() {
		return this.toXML().toString();
	}

	public List getRevisions() {
		return revisions;
	}
	

	public void setRevisions(List revisions) {
		this.revisions = revisions;
	}
	
}
